const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const standard_costs = sequelize.define(
    'standard_costs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

cost_version: {
        type: DataTypes.TEXT,
      
      

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"active",


"obsolete"

        ],

      },

material_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

labor_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

overhead_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

subcontract_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

total_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

approved_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  standard_costs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.standard_costs.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });

    db.standard_costs.belongsTo(db.users, {
      as: 'approved_by',
      foreignKey: {
        name: 'approved_byId',
      },
      constraints: false,
    });




    db.standard_costs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.standard_costs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return standard_costs;
};


